#!/usr/bin/env perl


use strict;
use CGI;
use warnings;


# =====================================================================
#         This value should be changed immediately!                   #
# =====================================================================


my $password = 'admin';
















#   CFAdmin - administration script for CGIForum
#   Copyright (C) 2000-2003, 2006 Markus Triska (triska@gmx.at)
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA




my $basedir		= '../cgiforum/';

my @child_parent	= ();
my %entry_info		= ();
my $section		= '';

my $default_headline	= 'None';
my $default_author	= 'Anonymous';


my %expand_day = (
    Mon => 'Monday', Tue => 'Tuesday', Wed => 'Wednesday',
    Thu => 'Thursday', Fri => 'Friday', Sat => 'Saturday',
    Sun => 'Sunday'
    );

my %month_number = (
    Jan => '01', Feb => '02', Mar => '03', Apr => '04', May => '05',
    Jun => '06', Jul => '07', Aug => '08', Sep => '09', Oct => '10',
    Nov => '11', Dec => '12'
    );




my $forum_hdr = '<html> <head><title>CFAdmin</title><STYLE TYPE=\"text/css\"> <!-- body {background-color: #EEEEEE} A:link {text-decoration:none; color:#000000} A:visited {text-decoration:none; color:#000000} UL.open {display:block} UL.closed {display:none} --> </style> </head> <body>';


my $cgi = new CGI;


sub filter_input
{
    # annihilate ".." etc. in section names, which could be used to
    # gain (read) access to upper directories

    my $string = shift;

    # contributed by b0iler@hotmail.com
    $string =~ s/([\&;\`'\|\"*\?\~\^\(\)\[\]\{\}\$\n\r])/\\$1/g;
    $string =~ s/\0//g;
    $string =~ s/\.\.//g;

    return $string;
}


sub fill_entry_time
{
    my $time = shift;

    if (substr ($time, 8, 1) eq ' ') { substr ($time, 8, 1) = '0'; }

    my ($weekday, $monthstr, $day, $Time, $year) = split / /, $time;
    $entry_info{'weekday'} = $expand_day{substr $weekday, 0, 3};
    $entry_info{'time'} = $Time;
    $entry_info{'day'} = $day;
    $entry_info{'monthstr'} = $monthstr;
    $entry_info{'month'} = $month_number{$monthstr};
    $entry_info{'year'} = $year;
    $entry_info{'hour'} = substr $Time, 0, 2;     # 16:03:22
    $entry_info{'minute'} = substr $Time, 3, 2;
    $entry_info{'second'} = substr $Time, 6, 2;
    $entry_info{'newsdate'} = $year . $month_number{$monthstr} . $day;
}

sub load_entry_time
{
    my $entrynumber = shift;
    my $entrypath = $basedir . "sections/$section/entries/$entrynumber";
    if (-e "$entrypath.inf") {
	open ENTRYINFO, "<$entrypath.inf";
	my $infoline = <ENTRYINFO>;
	close ENTRYINFO;
	chomp $infoline;
	my ($author_, $time, $email_) = split /\|/, $infoline;
	fill_entry_time $time;
    }
}

sub file_to_scalar
{
    my $file = pop;
    my $scalar = '';
    open FILE, "<$file" or print "invalid file\n" and die;
    while (<FILE>) { $scalar .= $_; }
    close FILE;
    return $scalar;
}

sub load_entry
{
    my ($entrynumber, $loadtext) = @_;
    $entry_info{'entrynumber'} = $entrynumber;

    my $entrypath = $basedir . "sections/$section/entries/$entrynumber";

    if ($loadtext) { $entry_info{'text'} = file_to_scalar "$entrypath.msg"; }

    my $hdlfile = $basedir . "sections/$section";
    if ($entrynumber == 0) {
	$hdlfile .= '/section.txt';
    } else {
	$hdlfile .= "/entries/$entrynumber.hdl";
    }

    open HDL, "<$hdlfile" or print "couldn't open $hdlfile\n" and die;
    my $headline = <HDL> || $default_headline;
    close HDL;

    chomp $headline;
    $entry_info{'headline'} = $headline;

    my $infoline = '||';
    if (-e "$entrypath.inf") {
	open ENTRYINFO, "<$entrypath.inf";
	$infoline = <ENTRYINFO>;
	chomp $infoline;
	close ENTRYINFO;
    }

    my ($author, $time, $email) = split /\|/, $infoline;
    fill_entry_time $time;
    my $authornum = 0;
    if ($author =~ /^REGISTERED/) {
	($authornum = $author) =~ s/REGISTERED//;
	chomp $authornum;
	open AUTHOR, "<$basedir". "users/$authornum.syn";
	$author = <AUTHOR>;
	close AUTHOR;
	chomp $author;
    }
    if ($email =~ /seeeml/) {
	open EMAIL, "<$basedir" . "users/$authornum.eml";
	$email = <EMAIL> || "";
	close EMAIL;
	chomp $email;
    }

    unless ($author) { $author = $default_author; }
    $entry_info{'author'} = $author;
    $entry_info{'email'} = $email;

    my $numhits = 0;
    # prior to version 1.04, no "cnt"-file was written by default
    if (-e "$entrypath.cnt") {
	open COUNT, "<$entrypath.cnt";
	$numhits = <COUNT>;
	close COUNT;
	chomp $numhits;
    }
    $entry_info{'numhits'} = $numhits;
}



sub build_tree
{
    my ($currentthread, $level) = @_;

    my @tree = ();
    foreach my $entry (grep /\|$currentthread\n/, @child_parent) {
	my ($child, $p_) = split /\|/, $entry;
	push @tree, "$child\|$level";
	push @tree, build_tree($child, $level + 1);
    }
    return @tree;
}


sub htmlify
{
    my $string = shift;

    $string =~ s//\&auml\;/g; $string =~ s//\&Auml\;/g;
    $string =~ s//\&ouml\;/g; $string =~ s//\&Ouml\;/g;
    $string =~ s//\&uuml\;/g; $string =~ s//\&Uuml\;/g;

    $string =~ s/\n/\<BR\>/g;
    $string =~ s//\&szlig\;/g;

    # to not interpret "<" and ">" as HTML-tag delimiters:
    # $string =~ s/</\&lt\;/g;
    # $string =~ s/>/\&gt\;/g;

    # ... add more special characters here

    return $string;
}


sub subst_variables
{
    my $template = shift;
    $template =~ s/\#\#(.*?)\#\#/htmlify (exists $entry_info{$1} ? $entry_info{$1} : "Warning...could NOT substitute $1")/ge;
    return $template;
}


sub print_entries
{
    my $startthread = shift;
    $entry_info{'section'} = $section;

    my $db = $basedir . "sections/$section/entries/entries.db";
    if (-e $db) {
	open ENTRYBASE, "<$db";
	@child_parent = <ENTRYBASE>;
	close ENTRYBASE;
    }

    # reverse chronological order for all children of "0" when
    # printing whole section
    if ($startthread == 0 && $#child_parent >= 0) {
	my $last = $#child_parent;
	my $index = 0;
	while ($index < $last) {
	    if ($child_parent[$index] =~ /\|0\n/)  {
		# find last child of 0
		while ($child_parent[$last] !~ /\|0\n/) { $last--; }

		# and swap them
		my $tmp = $child_parent[$index];
		$child_parent[$index] = $child_parent[$last];
		$child_parent[$last] = $tmp;
		$last--;
	    }
	    $index++;
	}
    }


    my @tree = build_tree $startthread, 1;

    my $parent_template = "<a href=\"cfadmin.pl?action=changeentry\&thesection=##section##\&entry=##entrynumber##\"><font color=\"#45CBA3\"> ##headline## </font> &nbsp; (##author##  |  ##month##.##day##.##year##  |  ##numhits##)</a> <a href=\"cfadmin.pl?action=delentry\&thesection=##section##\&entry=##entrynumber##\">Delete</a><ul>";

    my $parent_end = "</ul>";
    my $normal_template = "<a href=\"cfadmin.pl?action=changeentry\&thesection=##section##\&entry=##entrynumber##\"><font color=\"#45CBA3\"> ##headline## </font> &nbsp; (##author##  |  ##month##.##day##.##year##  |  ##numhits##)</a> <a href=\"cfadmin.pl?action=delentry\&thesection=##section##\&entry=##entrynumber##\">Delete</a><br>";


    my $parent_del_template = "<a href=\"cfadmin.pl?action=changeentry\&thesection=##section##\&entry=##entrynumber##\"> <font color=\"45CBA3\"> ##headline## </font> &nbsp; (##author##  |  ##month##.##day##.##year##  |  ##numhits##)</a><a href=\"cfadmin.pl?action=resentry\&thesection=##section##\&entry=##entrynumber##\">Restore</a> <font color=\"ff0000\"> DELETED</font><ul>";

    my $normal_del_template ="<a href=\"cfadmin.pl?action=changeentry\&thesection=##section##\&entry=##entrynumber##\"> <font color=\"45CBA3\"> ##headline## </font>(##author##  |  ##month##.##day##.##year##  |  ##numhits##)</a> <a href=\"cfadmin.pl?action=resentry\&thesection=##section##\&entry=##entrynumber##\">Restore</a> <font color=\"ff0000\"> DELETED</font><br>";

    my $prev_level = 0;
    print "<ul>";

    for (my $index = 0; $index <= $#tree; $index++) {
	my ($number, $level) = split /\|/, $tree[$index];
	while ($prev_level > $level) {
	    print subst_variables $parent_end;
	    $prev_level--;
	}
	$prev_level = $level;

	my $is_parent = 0;
	my $nextentry = $tree[$index + 1];
	if ($nextentry) {
	    my ($nextnumber, $nextlevel) = split /\|/, $nextentry;
	    $is_parent = $nextlevel > $level;
	}

	load_entry $number, 0;
	print "\n\n";
	my $is_deleted = (-e $basedir . "sections/$section/entries/$number.del");
	print subst_variables $is_parent
	    ? ( $is_deleted ? $parent_del_template : $parent_template)
	    : ( $is_deleted ? $normal_del_template : $normal_template);
    }

    while ($prev_level > 1) {
	print subst_variables $parent_end;
	$prev_level--;
    }

    print '</ul>';
}

sub resdel_password
{
    my $entrynumber = shift;
    print $forum_hdr;

    print <<EOF;
    <form action=\"/cgi-bin/cfadmin.pl\" method=\"POST\">
	<input type=\"hidden\" name=\"thesection\" value=\"$section\">
	<input type=\"hidden\" name=\"action\" value=\"resdel\">
	<input type=\"hidden\" name=\"entry\" value=\"$entrynumber\">
	Password: <input type=\"password\" name=\"password\">
	<input type=\"submit\" value=\"OK\">
	</form><br>
EOF
    print "</body></html>\n";
}

sub restore_delete
{
    print $forum_hdr;
    my $enteredpw = $cgi->param('password');
    chomp $enteredpw;
    $enteredpw eq $password
	or print "Wrong password!</body></html>\n" and exit;

    my $entrynum = $cgi->param('entry');
    $entrynum = filter_input $entrynum;
    if (-e $basedir . "sections/$section/entries/$entrynum.del") {
	unlink $basedir . "sections/$section/entries/$entrynum.del";
	print "Entry restored.</body></html>\n";
    } else {
	if (-e "$basedir" . "sections/$section/entries/$entrynum.msg") {
	    open FH, ">$basedir" . "sections/$section/entries/$entrynum.del";
	    print FH "THIS ENTRY IS DELETED\n" and close FH;
	    print "Entry deleted.</body></html>\n";
	}
    }
}


sub change_entry
{
    my $entrynumber = shift;
    load_entry $entrynumber, 1;

    print $forum_hdr;
    print <<EOF;

    On $entry_info{'weekday'}, $entry_info{'month'}.$entry_info{'day'}\.$entry_info{'year'}
    , <a href=\"mailto:$entry_info{'email'}\">$entry_info{'author'}</a> wrote at
	$entry_info{'hour'}:$entry_info{'minute'}:$entry_info{'second'} : <br><br>
	<form action=\"/cgi-bin/cfadmin.pl\" method="POST">
	<input type=\"hidden\" name=\"thesection\" value=\"$entry_info{'section'}\">
	<input type=\"hidden\" name=\"action\" value=\"dochange\">
	<input type=\"hidden\" name=\"entrynum\" value=\"$entry_info{'entrynumber'}\">
	<input type=\"text\" name=\"headline\" value=\"$entry_info{'headline'}\"><br><br>
	<textarea name=\"text\" rows=10 cols=100>$entry_info{'text'}</textarea><br><br>
Password: <input type=\"password\" name=\"password\">
<input type=\"submit\" value=\"Re-Submit\">
</form><br>
EOF

    print "<br><br><br>";
    print_entries $entrynumber;
    print "</body></html>";
}

sub write_change
{
    my $enteredpw = $cgi->param('password');
    chomp $enteredpw;
    print $forum_hdr;
    $enteredpw eq $password
	or print "Wrong password!</body></html>\n" and exit;

    my $text = $cgi->param('text');
    my $headline = $cgi->param('headline');
    my $thisentry = filter_input $cgi->param('entrynum');
    $thisentry =~ /^\d+$/ or print "invalid entry.\n" and die;

    if (-e "$basedir" . "sections/$section/entries/$thisentry.msg") {
	open MSG, ">$basedir" . "sections/$section/entries/$thisentry.msg";
	print MSG $text and close MSG;

	open HDL, ">$basedir" . "sections/$section/entries/$thisentry.hdl";
	print HDL $headline and close HDL;
    }
    print "Entry changed.</body></html>\n"
}


# Load configuration file

open CONF, "<cgiforum.conf";
while (<CONF>) {
    if (/^\#/) { next; }
    chomp;
    s/\r//g;
    my ($variable, $value) = split (/=/, $_);
    if ($variable =~ /basedir/i) {
	$basedir = $value;
	if (substr($basedir, -1, 1) ne '/') { $basedir .= '/'; }
    } elsif ($variable =~ /default_author/i) {
	$default_author = $value;
    } elsif ($variable =~ /default_headline/i) {
	$default_headline = $value;
    }
}

close CONF;

$section = filter_input ($cgi->param('thesection') || 'default');
$entry_info{'basedir'} = $basedir;

print "Content-type: text/html\n\n";

if (!$cgi->param('action') || ($cgi->param('action') eq 'showsection')) {
    print $forum_hdr;
    print_entries 0;
    print '</body></html>';
} elsif ($cgi->param('action') eq 'changeentry') {
    change_entry filter_input($cgi->param('entry'));
} elsif ($cgi->param('action') eq 'dochange') {
    write_change;
} elsif ($cgi->param('action') eq 'resentry' or $cgi->param('action') eq 'delentry') {
    resdel_password filter_input($cgi->param('entry'));
} elsif ($cgi->param('action') eq 'resdel') {
    restore_delete;
}
